#ifndef ANIMATION_HPP_INCLUDED
#define ANIMATION_HPP_INCLUDED

#include "CacheableNode.hpp"
#include "../JavaClass/Class.hpp"
#include <vector>
#include <cstdint>

namespace Internal
{
    class Animation : public CacheableNode
    {
        public:
            Animation(const void* Obj);

            Animation() = default;
            Animation(Animation&& Obj) = default;
            Animation(const Animation& Obj) = default;
            Animation& operator=(Animation&& Obj) = default;
            Animation& operator=(const Animation& Obj) = default;

            static Class GetClass();

            std::vector<std::int32_t> GetFrameIDs() const;
            std::vector<std::int32_t> GetInterleave() const;
            std::int32_t GetLeftHandItem() const;
            std::int32_t GetModelID() const;
            std::int32_t GetRightHandItem() const;

    };
}

#endif // ANIMATION_HPP_INCLUDED
