#ifndef ANIMATIONSET_HPP_INCLUDED
#define ANIMATIONSET_HPP_INCLUDED

#include "CacheableNode.hpp"
#include "../JavaClass/Class.hpp"
#include <vector>
#include <cstdint>
#include "Skin.hpp"
#include "FrameAngles.hpp"

namespace Internal
{
    class AnimationSet : public CacheableNode
    {
        public:
            AnimationSet(const void* Obj);

            AnimationSet() = default;
            AnimationSet(AnimationSet&& Obj) = default;
            AnimationSet(const AnimationSet& Obj) = default;
            AnimationSet& operator=(AnimationSet&& Obj) = default;
            AnimationSet& operator=(const AnimationSet& Obj) = default;

            static Class GetClass();

            std::vector<std::vector<FrameAngles>> GetFrameAngles() const;
            std::vector<FrameAngles> GetFrameAngles(std::int32_t I) const;
            FrameAngles GetFrameAngles(std::int32_t I, std::int32_t II) const;
            Skin GetSkin() const;
            std::int32_t GetMatrixIndex() const;

    };
}

#endif // ANIMATIONSET_HPP_INCLUDED
