#ifndef FRAME_HPP_INCLUDED
#define FRAME_HPP_INCLUDED

#include "../JavaClass/Object.hpp"
#include "../JavaClass/Class.hpp"
#include <vector>
#include <cstdint>
#include "Skin.hpp"

namespace Internal
{
    class Frame : public Object
    {
        public:
            Frame(const void* Obj);

            Frame() = default;
            Frame(Frame&& Obj) = default;
            Frame(const Frame& Obj) = default;
            Frame& operator=(Frame&& Obj) = default;
            Frame& operator=(const Frame& Obj) = default;

            static Class GetClass();

            std::vector<std::int32_t> GetIndices() const;
            bool GetShowing() const;
            Skin GetSkin() const;
            std::vector<std::int32_t> GetTranslatorX() const;
            std::vector<std::int32_t> GetTranslatorY() const;
            std::vector<std::int32_t> GetTranslatorZ() const;
            std::int32_t GetTranslatorsLength() const;

    };
}

#endif // FRAME_HPP_INCLUDED
