#ifndef FRAMEANGLES_HPP_INCLUDED
#define FRAMEANGLES_HPP_INCLUDED

#include "../JavaClass/Class.hpp"
#include <cstdint>
#include <vector>

namespace Internal
{
    class FrameAngles : public Object
    {
        public:
            FrameAngles(const void* Obj);

            FrameAngles() = default;
            FrameAngles(FrameAngles&& Obj) = default;
            FrameAngles(const FrameAngles& Obj) = default;
            FrameAngles& operator=(FrameAngles&& Obj) = default;
            FrameAngles& operator=(const FrameAngles& Obj) = default;

            static Class GetClass();

            std::vector<float> GetAngles() const;

            float GetMaxAngle() const;
            std::int32_t GetMaxFrame() const;
            float GetMinAngle() const;
            std::int32_t GetMinFrame() const;

    };
}

#endif // FRAMEANGLES_HPP_INCLUDED
