#ifndef GRAPHICSOBJECT_HPP_INCLUDED
#define GRAPHICSOBJECT_HPP_INCLUDED

#include "Renderable.hpp"
#include "../JavaClass/Class.hpp"
#include "Animation.hpp"
#include <cstdint>

namespace Internal
{
    class GraphicsObject : public Renderable
    {
        public:
            GraphicsObject(const void* Obj);

            GraphicsObject() = default;
            GraphicsObject(GraphicsObject&& Obj) = default;
            GraphicsObject(const GraphicsObject& Obj) = default;
            GraphicsObject& operator=(GraphicsObject&& Obj) = default;
            GraphicsObject& operator=(const GraphicsObject& Obj) = default;

            static Class GetClass();

            std::int32_t GetAnimationFrame() const;
            bool GetFinished() const;
            std::int32_t GetHeight() const;
            std::int32_t GetID() const;
            std::int32_t GetPlane() const;
            std::int32_t GetX() const;
            std::int32_t GetY() const;

    };
}

#endif // GRAPHICSOBJECT_HPP_INCLUDED
