#ifndef MENUCONTAINER_HPP_INCLUDED
#define MENUCONTAINER_HPP_INCLUDED

#include "../JavaClass/Object.hpp"
#include "../JavaClass/Class.hpp"
#include <vector>
#include <string>
#include <cstdint>

namespace Internal
{
    class MenuContainer : public Object
    {
        public:
            MenuContainer(const void* Obj);

            MenuContainer() = default;
            MenuContainer(MenuContainer&& Obj) = default;
            MenuContainer(const MenuContainer& Obj) = default;
            MenuContainer& operator=(MenuContainer&& Obj) = default;
            MenuContainer& operator=(const MenuContainer& Obj) = default;

            static Class GetClass();

            std::vector<std::string> GetActions() const;
            std::vector<MenuContainer> GetChildren() const;
            MenuContainer GetChildren(std::int32_t I) const;
            std::int32_t GetCount() const;
            std::int32_t GetHeight() const;
            std::vector<std::string> GetTargets() const;
            std::int32_t GetWidth() const;
            std::int32_t GetX() const;
            std::int32_t GetY() const;

    };
}

#endif // MENUCONTAINER_HPP_INCLUDED
