#ifndef MODEL_HPP_INCLUDED
#define MODEL_HPP_INCLUDED

#include "Renderable.hpp"
#include "../JavaClass/Class.hpp"
#include <vector>
#include <cstdint>

namespace Internal
{
    class Model : public Renderable
    {
        public:
            Model(const void* Obj);

            Model() = default;
            Model(Model&& Obj) = default;
            Model(const Model& Obj) = default;
            Model& operator=(Model&& Obj) = default;
            Model& operator=(const Model& Obj) = default;

            static Class GetClass();

            std::vector<std::vector<std::int32_t>> GetFrameMapIndices() const;
            std::vector<std::int32_t> GetIndicesA() const;
            std::vector<std::int32_t> GetIndicesB() const;
            std::vector<std::int32_t> GetIndicesC() const;
            std::int32_t GetIndicesLength() const;
            std::int32_t GetVerticesLength() const;
            std::vector<std::int32_t> GetVerticesX() const;
            std::vector<std::int32_t> GetVerticesY() const;
            std::vector<std::int32_t> GetVerticesZ() const;

            std::vector<std::vector<std::int32_t>> GetInt2DArray1() const;
            std::vector<std::vector<std::int32_t>> GetInt2DArray2() const;

    };
}

#endif // MODEL_HPP_INCLUDED
