#ifndef REGIONCONTAINER_HPP_INCLUDED
#define REGIONCONTAINER_HPP_INCLUDED

#include "../JavaClass/Object.hpp"
#include "../JavaClass/Class.hpp"
#include <cstdint>
#include "Renderable.hpp"
#include <vector>
#include "CollisionData.hpp"
#include "Deque.hpp"
#include "NPC.hpp"
#include "PlayerUpdater.hpp"
#include "Player.hpp"
#include "Region.hpp"

namespace Internal
{
    class RegionContainer : public Object
    {
        public:
            RegionContainer(const void* Obj);

            RegionContainer() = default;
            RegionContainer(RegionContainer&& Obj) = default;
            RegionContainer(const RegionContainer& Obj) = default;
            RegionContainer& operator=(RegionContainer&& Obj) = default;
            RegionContainer& operator=(const RegionContainer& Obj) = default;

            static Class GetClass();

            std::int32_t GetClientPlane() const;
            std::int32_t GetClientX() const;
            std::int32_t GetClientY() const;
            std::vector<CollisionData> GetCollisionMaps() const;
            CollisionData GetCollisionMap(std::int32_t Plane) const;
            Deque GetGraphicsObjects() const;
            std::vector<std::vector<std::vector<Deque>>> GetGroundItems() const;
            std::vector<std::vector<Deque>> GetGroundItems(std::int32_t Plane) const;
            Deque GetGroundItems(std::int32_t X, std::int32_t Y, std::int32_t Plane) const;
            std::int32_t GetNPCCount() const;
            std::vector<std::int32_t> GetNPCIndices() const;
            std::vector<NPC> GetNPCs() const;
            NPC GetNPC(std::int32_t Index) const;
            PlayerUpdater GetPlayerUpdater() const;
            std::vector<Player> GetPlayers() const;
            Player GetPlayer(std::int32_t Index) const;
            Deque GetProjectiles() const;
            Region GetRegion() const;
            std::vector<std::vector<std::vector<std::int32_t>>> GetTileHeights() const;
            std::int32_t GetTileHeights(std::int32_t X, std::int32_t Y, std::int32_t Plane) const;
            std::vector<std::vector<std::vector<std::int8_t>>> GetTileSettings() const;
            std::int8_t GetTileSettings(std::int32_t X, std::int32_t Y, std::int32_t Plane) const;
    };
}

#endif // REGIONCONTAINER_HPP_INCLUDED
