#ifndef SCENETILE_HPP_INCLUDED
#define SCENETILE_HPP_INCLUDED

#include "Node.hpp"
#include "../JavaClass/Class.hpp"
#include "DecorativeObject.hpp"
#include <vector>
#include "GameObject.hpp"
#include "GroundObject.hpp"
#include "ItemLayer.hpp"
#include <cstdint>
#include "WallObject.hpp"

namespace Internal
{
    class SceneTile : public Node
    {
        public:
            SceneTile(const void* Obj);

            SceneTile() = default;
            SceneTile(SceneTile&& Obj) = default;
            SceneTile(const SceneTile& Obj) = default;
            SceneTile& operator=(SceneTile&& Obj) = default;
            SceneTile& operator=(const SceneTile& Obj) = default;

            static Class GetClass();

            DecorativeObject GetDecorativeObject() const;
            std::vector<GameObject> GetGameObjects() const;
            GameObject GetGameObjects(std::int32_t I) const;
            GroundObject GetGroundObject() const;
            ItemLayer GetItemLayer() const;
            std::int32_t GetPlane() const;
            WallObject GetWallObject() const;
            std::int32_t GetX() const;
            std::int32_t GetY() const;

    };
}

#endif // SCENETILE_HPP_INCLUDED
