#ifndef WIDGETGROUP_HPP_INCLUDED
#define WIDGETGROUP_HPP_INCLUDED

#include "../JavaClass/Object.hpp"
#include "../JavaClass/Class.hpp"
#include "Cache.hpp"
#include "Widget.hpp"

namespace Internal
{
    class WidgetGroup : public Object
    {
        public:
            WidgetGroup(const void* Obj);

            WidgetGroup() = default;
            WidgetGroup(WidgetGroup&& Obj) = default;
            WidgetGroup(const WidgetGroup& Obj) = default;
            WidgetGroup& operator=(WidgetGroup&& Obj) = default;
            WidgetGroup& operator=(const WidgetGroup& Obj) = default;

            static Class GetClass();

            Cache GetWidgetFontCache() const;
            std::vector<std::vector<Widget>> GetWidgets() const;
            std::vector<Widget> GetWidgets(std::int32_t I) const;
            Widget GetWidgets(std::int32_t I, std::int32_t II) const;

    };
}

#endif // WIDGETGROUP_HPP_INCLUDED
