#ifndef DECORATIVEOBJECTS_HPP_INCLUDED
#define DECORATIVEOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/DecorativeObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>
#include <regex>

namespace DecorativeObjects
{
    std::vector<Interactable::DecorativeObject> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::DecorativeObject> GetAll();
    std::vector<Interactable::DecorativeObject> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::DecorativeObject> GetAll(const std::regex& Name, std::int32_t Distance = -1);
    std::vector<Interactable::DecorativeObject> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::DecorativeObject> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::DecorativeObject> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::DecorativeObject> GetAll(const std::function<bool (const Interactable::DecorativeObject&)>& Filter, std::int32_t Distance = -1);

    Interactable::DecorativeObject Get(const Tile& T);
    Interactable::DecorativeObject Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::DecorativeObject Get(const std::regex& Name, std::int32_t Distance = -1);
    Interactable::DecorativeObject Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::DecorativeObject Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::DecorativeObject Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::DecorativeObject Get(const std::function<bool (const Interactable::DecorativeObject&)>& Filter, std::int32_t Distance = -1);
}

#endif // DECORATIVEOBJECTS_HPP_INCLUDED
