#ifndef GROUNDOBJECTS_HPP_INCLUDED
#define GROUNDOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/GroundObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>
#include <regex>

namespace GroundObjects
{
    std::vector<Interactable::GroundObject> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::GroundObject> GetAll();
    std::vector<Interactable::GroundObject> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::GroundObject> GetAll(const std::regex& Name, std::int32_t Distance = -1);
    std::vector<Interactable::GroundObject> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::GroundObject> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::GroundObject> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::GroundObject> GetAll(const std::function<bool (const Interactable::GroundObject&)>& Filter, std::int32_t Distance = -1);

    Interactable::GroundObject Get(const Tile& T);
    Interactable::GroundObject Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::GroundObject Get(const std::regex& Name, std::int32_t Distance = -1);
    Interactable::GroundObject Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::GroundObject Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::GroundObject Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::GroundObject Get(const std::function<bool (const Interactable::GroundObject&)>& Filter, std::int32_t Distance = -1);
}

#endif // GROUNDOBJECTS_HPP_INCLUDED
