#ifndef PLAYERS_HPP_INCLUDED
#define PLAYERS_HPP_INCLUDED

#include "../../Game/Interactable/Player.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>
#include <regex>

namespace Players
{
    Interactable::Player GetLocal();
    std::vector<Interactable::Player> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::Player> GetAll();
    std::vector<Interactable::Player> GetAll(const Tile& Tile);
    std::vector<Interactable::Player> GetAll(const std::regex& Name, std::int32_t Distance = -1);
    std::vector<Interactable::Player> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::Player> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::Player> GetAll(const std::function<bool (Interactable::Player&)>& Filter, std::int32_t Distance = -1);

    Interactable::Player Get(const Tile& Tile);
    Interactable::Player Get(const std::regex& Name, std::int32_t Distance = -1);
    Interactable::Player Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::Player Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::Player Get(const std::function<bool (const Interactable::Player&)>& Filter, std::int32_t Distance = -1);
}

#endif // PLAYERS_HPP_INCLUDED
