#ifndef WALLOBJECTS_HPP_INCLUDED
#define WALLOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/WallObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>
#include <regex>

namespace WallObjects
{
    std::vector<Interactable::WallObject> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::WallObject> GetAll();
    std::vector<Interactable::WallObject> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::WallObject> GetAll(const std::regex& Name, std::int32_t Distance = -1);
    std::vector<Interactable::WallObject> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::WallObject> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::WallObject> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::WallObject> GetAll(const std::function<bool (const Interactable::WallObject&)>& Filter, std::int32_t Distance = -1);

    Interactable::WallObject Get(const Tile& T);
    Interactable::WallObject Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::WallObject Get(const std::regex& Name, std::int32_t Distance = -1);
    Interactable::WallObject Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::WallObject Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::WallObject Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::WallObject Get(const std::function<bool (const Interactable::WallObject&)>& Filter, std::int32_t Distance = -1);
}

#endif // WALLOBJECTS_HPP_INCLUDED
